<template>
    <div class="container" id="container-register">
        <div id="register">
            <div>
                <div>
                    <div>
                        <b-card no-body class="overflow-hidden" style="max-width: 1000px;">
                            <b-row no-gutters>
                                <b-col md="6">
                                    <b-card-img src="https://picsum.photos/400/400/?image=20" alt="Image"
                                        class="rounded-0"></b-card-img>
                                </b-col>
                                <b-col md="6">
                                    <b-card-body title="Connexion">
                                        <b-form @reset="onReset" method="post" @submit.prevent="login">
                                            <b-form-group id="input-group-1" label="Adresse mail:" label-for="input-1">
                                                <b-form-input id="input-1" v-model="form.mail" type="mail"
                                                    placeholder="troov@mail.com" required >
                                                </b-form-input>
                                            </b-form-group>

                                            <b-form-group id="input-group-2" label="Mot de passe:" label-for="input-2">
                                                <b-form-input id="input-2" v-model="form.password"
                                                    placeholder="SuperMotDePasse" type="password" required>
                                                </b-form-input>
                                            </b-form-group>
                                            <Notification :messages="error" v-if="error" />

                                            <div id="group-btn-register">
                                                <b-button type="submit" variant="outline-secondary">Se connecter
                                                </b-button>
                                                <b-button type="reset" variant="outline-secondary">Annuler
                                                </b-button>
                                            </div>

                                        </b-form>
                                        <div class="has-text-centered" style="margin-top: 20px">
                                            <p>
                                                Vous n'avez pas de compte ? <nuxt-link to="/register">Inscription
                                                </nuxt-link>
                                            </p>
                                        </div>
                                    </b-card-body>
                                </b-col>
                            </b-row>
                        </b-card>
                    </div>
                </div>

            </div>
        </div>
    </div>

</template>

<script>
import Notification from '~/components/Notification';

export default {
    components: {
        Notification,
    },
    data() {
        return {
            form: {
                mail: '',
                password: '',
            },
            error: null,
        }
    },
    methods: {
        async login() {
            this.error = null;
            const { mail, password } = this.form;
            try {
             const res =  await this.$auth.loginWith('local', {
                    data: {
                        mail,
                        password
                    }

                });
            await this.$auth.setUserToken(res.data.token)

            } catch (e) {
                const errors = Object.values(e.response.data);
                this.error = errors.flat();
            }
        },
        onReset(event) {
            event.preventDefault()
            this.form.mail = ''
            this.form.password = ''
            this.error = null;
        }
    }
}
</script>